#!/usr/bin/ruby
#encoding: UTF-8
=begin
/***************************************************************************
 *   ©2021-2021, Michael Uplawski <michael.uplawski@uplawski.eu>           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
=end

require_relative 'logging'
require 'mail'

class FMail
  extend Logging
  @@log = init_logger(STDOUT)

  def initialize(mail_text)
    @log = @@log
    if !mail_text || mail_text.empty?
      @log.error('No mail-text provided. Aborting!')
      exit false
    end
    @mail_text = mail_text
    # @log.debug('mail text is ' << @mail_text)
    extr_received
  end

  attr_reader :received

  private 

  def extr_received
    @mail = Mail::read_from_string(@mail_text)
    headers = @mail.header_fields
    @received = headers.filter{|h| h.name == 'Received'}.collect{|h| h.unparsed_value}
    @log.debug("found received-headers: " << @received.to_s)
  end

end

############ TEST ##############
if __FILE__ == $0
  ml = FMail.new(ARGF.read)
end
